# =====================================================================
# grant.awk: RPC I/O functions for example.grant
#
# Copyright (c) 2003 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or   
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License   
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================

# =====================================================================
# int _userproc(int mode)
# =====================================================================

function _userproc(mode,		value,pw_len,nick) {

   if (mode == _O_REQUEST) {

      # Check for valid password syntax.

      value = _request("password")

      pw_len = length(value)

      if (value !~ /^[-+_a-zA-Z0-9@.!]*$/ || \
	 (pw_len < 6 || pw_len > 12)) _wwwexit(_EXITFAULT,"0041 password")
      else _rcset("CSA_AUTH_PW",value)

      # Check for valid userid syntax.

      value = _request("userid")

      # remove any surrounding blanks.
      nick = _strip(value)

      if (value !~ /^[a-z][a-z][-_a-z0-9@.]*$/)
		_wwwexit(_WXITFAULT, "0041 userid")
      else _rcset("CSA_AUTH_USER",value)
   }
}

# EOF
